/*****************************************************************************/
/*
    Anny's Lab 1.0
    made by m@rtlin, VII-IX 2012
    martlin@seznam.cz, http://www.martlins-web.tode.cz/
    Licence: GNU/GPL, Open Source

    Multiplatformní (primárně určena pro GNU/Linux) textová bludišťovka volitelně využívající knihovnu ncurses
    Přeji Hodně zábavy!
*/
/*
    Soubor core.cpp:

    Funkce hry jako takové (jádro hry).
*/
/*****************************************************************************/
#ifndef _al_core
#define _al_core

#include <cstdlib>
#include <cstdio>
#include <ctime>
#include <string>
#include <queue>

#include "declarations.cpp"
#include "fundec.cpp"
#include "others.cpp"
#include "main.cpp"
#include "map.cpp"

/******************************************************************************/
/** Jádro hry - herní funkce **************************************************/

/* --- Definice funkcí ----------------------------------------------------- */

int parseArgs(int argc, std::queue<std::string> argv) { //načte argumenty z příkazové řádky a vrátí počet varování/chyb - 0 při 100% úspěchu
    #define READ_SW_WITH_W_AND_H(paramwidth, paramheight)\
        argv.pop();\
        try {\
            if (argv.empty() || isSwitch(argv.front()))\
                throw "Nezadána výška.";\
\
            if (!isNumeric(argv.front())) {\
                argv.pop();\
                throw "Invalidní výška.";\
            }\
\
            paramwidth=atoi(argv.front().c_str());\
            argv.pop();\
\
            if (argv.empty() || isSwitch(argv.front()))\
                throw "Nezadána šířka.";\
\
            if (!isNumeric(argv.front())) {\
                argv.pop();\
                throw "Invalidní šířka.";\
            }\
\
            paramheight=atoi(argv.front().c_str());\
            argv.pop();\
        } catch (const char* errmsg){\
            fprintf(stderr,"Přepínač %s: %s Přepínač byl ignorován.\n", actSwitch.c_str(), errmsg);\
            errors++;\
        }\

    int errors=0;
    std::string actSwitch;

        while (!argv.empty()) {    //prvni argument jen azev samotneho programu, ten nas nezajima
        actSwitch=argv.front();

        if (actSwitch.compare("-h")==0 || actSwitch.compare("--help")==0) {
            argv.pop(); //zbytečné, ale přece
            help();
            exit(0);
        }

        if (actSwitch.compare("-o")==0 || actSwitch.compare("--onegame")==0) {
            argv.pop();

            if (!argv.empty() && isNumeric(argv.front())) {
                gameParams::seed=atoi(argv.front().c_str());
                argv.pop();
            } else {
                gameParams::seed=rand();
            }
            gameParams::onlyOneGame=true;
            continue;
        }

        #ifndef USE_CURSES
            if (actSwitch.compare("-t")==0 || actSwitch.compare("--term")==0) {
                READ_SW_WITH_W_AND_H(gameParams::termWidth, gameParams::termHeight);
                continue;
            }

        #endif

        if (actSwitch.compare("-m")==0 || actSwitch.compare("--map")==0) {
            READ_SW_WITH_W_AND_H(gameParams::width, gameParams::height);
            try {
                int exp=0;
                if (gameParams::height<gameParams::width) { //na sirku
                    if (gameParams::height<5)
                        exp+=1;   //nizky
                    if (gameParams::width<7)
                        exp+=10;   //uzky
                    if (exp!=0)
                        throw(exp);
                    else
                        continue;   //nic

                } else {    //na vysku
                    if (gameParams::height<7)
                        exp+=1;   //nizky
                    if (gameParams::width<5)
                        exp+=10;   //uzky
                    if (exp!=0)
                        throw(exp);
                    else
                        continue;   //nic
                }
            } catch (int exp){
                bool isLow=(bool)exp%10==1,
                     isNarrow=(bool)exp/10==1;

                fprintf(stderr,"Přepínač %s: Labyrint je příliš %s. Minimální rozměry jsou 5x7 nebo 7x5. ", actSwitch.c_str(),
                        isNarrow?(isLow?"nízký a úzký":"úzký"):(isLow?"nízký":""));

                if (isNarrow) {
                    errors++;
                    gameParams::width=(gameParams::height<5) ? 7 : 5; //pokud by byl nízký, musí se nastavit široký
                    fprintf(stderr,"Byl rostažen na šířku %d. ", gameParams::width);
                }

                 if (isLow) {
                    errors++;
                    gameParams::height=(gameParams::width<7) ? 7 : 5; //pokud by byl úzký, musí se nastavit vysoký  -zbytečné, ošetřeno výše
                    fprintf(stderr,"Byl rostažen na výšku %d. ", gameParams::height);
                }
                fprintf(stderr, "\n");
                continue;
            }
        }

        if (actSwitch.compare("-s")==0 || actSwitch.compare("--startonleft")==0) {
            argv.pop();
            gameParams::startOnLeft=true;
            continue;
        }

        if (actSwitch.compare("-f")==0 || actSwitch.compare("--finishonright")==0) {
            argv.pop();
            gameParams::finishOnRight=true;
            continue;
        }

        if (actSwitch.compare("-w")==0 || actSwitch.compare("--ways")==0) {
            argv.pop();
            try {
                if (argv.empty() || isSwitch(argv.front())) //je-li již fronta prázdná a nebo je další arguemnt další přepínač
                    throw "Nezadán argument N.";

                if (!isNumeric(argv.front())) {
                    argv.pop();
                    throw "Invalidní hodnota argumentu N.";
                }

                gameParams::shortcuts=atoi(argv.front().c_str());
                argv.pop();
            } catch (const char* errmsg) {
                fprintf(stderr,"Přepínač %s: %s Přepínač byl ignorván.\n", actSwitch.c_str(), errmsg);
                errors++;
            }
            continue;
        }

        if (actSwitch.compare("-n")==0 || actSwitch.compare("--notshow")==0) {
            argv.pop();
            gameParams::visible=false;
            continue;
        }

        if (actSwitch.compare("-d")==0 || actSwitch.compare("--dropseeds")==0) {
            argv.pop();
            gameParams::dropSeeds=true;
            continue;
        }

        if (actSwitch.compare("-c")==0 || actSwitch.compare("--chars")==0) {
            argv.pop();
            //WEVSPF
            try {
                if (argv.empty() || (isSwitch(argv.front()) && actSwitch.length()!=6))  //není-li zadán další argument, nebo to není ona šestice (nemá délku 6 a je to přepínač)
                    throw "Nezadána šestice znaků WEVSPF.";

                if (argv.front().length()!=6) {
                    argv.pop();
                    throw "Nezadáno 6 znaků (W, E, V, S, P a F).";
                }

                {
                using namespace gameParams;
                    wall=argv.front()[0];
                    empty=argv.front()[1];
                    visited=argv.front()[2];
                    start=argv.front()[3];
                    player=argv.front()[4];
                    finish=argv.front()[5];
                }
                argv.pop();
                continue;
            } catch (const char* errmsg) {
                fprintf(stderr,"Přepínač %s: %s Přepínač byl ignorován.\n", actSwitch.c_str(), errmsg);
                errors++;
                continue;
            }
        }

        if (actSwitch.compare("-l")==0 || actSwitch.compare("--lab")==0) {
            argv.pop();
            //S nebo C
            try {
                if (argv.empty() || isSwitch(argv.front())) //je-li již fronta prázdná a nebo je další arguemnt další přepínač
                    throw "Nezadána parametr T.";

                switch (toUpperCase(argv.front()[0])) {
                    case 'S': gameParams::algorithm=beginRand; break;
                    case 'C': gameParams::algorithm=fullRand; break;
                    default: throw "Zadán chybný parametr T. Povolené hodnoty jsou \"S\" nebo \"C\"."; break;
                }
                argv.pop();
                continue;
            } catch (const char* errmsg) {
                fprintf(stderr,"Přepínač %s: %s Přepínač byl ignorván.\n", actSwitch.c_str(), errmsg);
                errors++;
                continue;
            }
        }

        if (actSwitch.compare("-p")==0 || actSwitch.compare("--permutations")==0) {
            argv.pop();
            try {
                if (argv.empty() || isSwitch(argv.front())) //je-li již fronta prázdná a nebo je další arguemnt další přepínač
                    throw "Nezadán argument N.";

                if (!isNumeric(argv.front())) {
                    argv.pop();
                    throw "Invalidní hodnota argumentu N.";
                }

                gameParams::permutations=atoi(argv.front().c_str());
                argv.pop();
            } catch (const char* errmsg) {
                fprintf(stderr,"Přepínač %s: %s Přepínač byl ignorován.\n", actSwitch.c_str(), errmsg);
                errors++;
            }
            continue;
        }

        {   //jakoby else větev
            fprintf(stderr, "Neznámý přepínač %s. Byl ingornován. Viz -h nebo --help pro nápovědu.\n", actSwitch.c_str());
            argv.pop();
            errors++;
        }
    }

    if (errors>0) { //nastaly-li nějaké chyby, vypiš je vyčkej na reakci
        char c;
        printf("Stiskněte Enter pro pokračování, Q pro konec.\n");
        c=toUpperCase(getchar());
        if (c=='Q')
            exit(errors);
    }

    return errors;
}


void restoreDefaults(void) {    //obnoví komplet všechno výchozí nastavení nutno zavolat ihned po startu programu!!
    using namespace gameParams;
    dimsPerms[0]=top;
    dimsPerms[1]=left;
    dimsPerms[2]=bottom;
    dimsPerms[3]=right;

    onlyOneGame=false;
    seed=0;

    restoreDefaultMapS();
    restoreDefaultGameS();
}

void restoreDefaultMapS(void) { //obnoví nastavení labyrintu(ů)
    using namespace gameParams;
    width=80;
    height=25;
    algorithm=fullRand;
    startOnLeft=false;
    finishOnRight=false;
    shortcuts=5;
    visible=true;
    dropSeeds=false;
}

void restoreDefaultGameS(void) {    //obnoví nastavení hry jako takové
    using namespace gameParams;
    #ifndef USE_CURSES
        termWidth=80;
        termHeight=25;
    #endif
    permutations=1;
    empty=' ';
    wall='W';
    visited='.';
    start='S';
    finish='F';
    player='@';
}


void mainMenu(void) {   //iteraktoivní hlavní menu
    char select='\0';

    do {
        select='\0';
        CLEAR;
        printLogo();

        PRINTF(" HLAVNI MENU\n\n");
        PRINTF("  0  -  Hrat nahodny labyrint!\n");
        PRINTF("  1  -  Hrat labyrint cislo ...\n");
        PRINTF("  2  -  Zmenit nastaveni labyrintu\n");
        PRINTF("  3  -  Zmenit pokrocile nastaveni\n");
        PRINTF("  4  -  Spustit hru s pribehem\n");
        PRINTF("  5  -  Napoveda\n");
        PRINTF("  6  -  Konec\n");

        do {
            select=READKEY;
        } while (select<'0' && select>'6');

        switch (select) {
            case '0': {
                    gameParams::seed=time(NULL);

                    Map map;
                    map.play();
                    break;
                }
            case '1': {
                    CLEAR;
                    PRINTF("Hrat labyrint cislo... ");
                    SCANF("%d", &(gameParams::seed));

                    Map map;
                    map.play();
                    break;

                    } break;
            case '2':
                    mapSettings();
                    break;
            case '3':
                    gameSettings();
                    break;
            case '4':
                    campaigne();
                    break;
            case '5':
                    gameHelp();
                    break;
        }


    } while (select!='6');
    return;
}

void printLogo(void) {

        PRINTF("                           ___    |  '-,                |                    \n");
        PRINTF("   /\\   |\\  | |\\  | \\ / | (   \\   |    |                |         ________   \n");
        PRINTF("  /__\\  | \\ | | \\ |  Y     '-,    |    |       uuu      |        |        |  \n");
        PRINTF(" /    \\ |  \\| |  \\|  |    \\___)   |    |      38 o\\     |        |  EXIT  |  \n");
        PRINTF("'-.     ,-.      .                |    |    __3  C      |        |________|  \n");
        PRINTF("   '.,-'   '-._.'       ___       |_,-'|   /     \\      |                    \n");
        PRINTF("  .-''-.|        /\\    |   \\      |    |  / /    |      |                    \n");
        PRINTF("-'      '-.     /  \\   |___/      |    | ( (    /_      |         made by    \n");
        PRINTF("     ,- |  '.  /____\\  |   \\      |    '-,\\_)'-/__)     |    (c)  m@rtlin    \n");
        PRINTF("-. ,'   |____ /      \\ |___/      |    __/   \\  \\       |           2012     \n");
        PRINTF("_-'.            ,' '-.      %5s |   |  __/  \\  )-,_   |                    \n", VERSION);
        PRINTF("____',________,'______'-.______.-_|   |_|     / /    '-,|____________________\n");
        PRINTF("      '-.___-'            '-.-'              /__\\                            \n");
//      PRINTF("______________________________________________________________________________\n");

}

void help(void) {
    using namespace gameParams;
    printf("Anny's Lab %s nápověda\n", VERSION);
    printf("Program lze spustit bez jakýchkoliv parametrů a bude obsluhován interaktivně.\n");
    printf("Volitelné parametry:\n");
    printf(" -h, --help             Zobrazí tuto nápovědu a zkončí\n");
    printf(" -o, --onegame [N]      Jen spustí jednu hru (bez Menu) a zkončí.\n   N je číslo spuštěného labyrintu. Pokud není uvedeno, bude náhodné.\n\n");
    printf(" Potlačení výchozích parametrů hry:\n");
    #ifndef USE_CURSES
        printf(" -t, --term W H         Labyrint bude vykreslovat do terminálu o velikost WxH\n   (výchozí %dx%d).\n", termWidth, termHeight);
    #endif
    printf(" -m, --map W H          Velikost labyrintu bude WxH (výchozí %dx%d)\n", width, height);
    printf(" -s, --startonleft      Vloží start na levý kraj labyrintu (ne libovolně\n   v labyrintu)\n");
    printf(" -f, --finishonright    Vloží cíl na pravý kraj labyrintu (ne libovolně\n   v labyrintu)\n");
    printf(" -w, --ways N           Maximální počet řešení labyrintu (výchozí: %d)\n\n", shortcuts);
    printf(" -n, --notshow          Labyrint nebude zobrazen (\"hra naslepo\")\n");
    printf(" -d, --dropseeds        Na každé navštívené políčko \"hodí semínko\"\n");

    printf(" -c, --chars WEVSPF     Bude vykreslovat znaky WEVSPF místo výchozích (%c%c%c%c%c%c).\n",
            wall, empty, visited, start, player, finish);
    printf("   Význam jednotlivých znaků:\n     W-zeď, E-prázdné pole, V-semínko-navšívené pole (pokud je zapnuté),\n     S-start, P-hráč, F-cíl\n\n");

    printf(" -l, --lab T            Typ labyrintu. T může být S (jednoduchý, rovné cesty)\n   nebo C (složitý, klikaté cesty)\n");
    printf(" -p, --permutations N   Počet zámněn směrů při generování labyrintu\n   (minimálně 1, ideálně 3, nad 3 zbytečně moc)\n\n");

    printf("Při zadávání velké velikosti labyrintu (--map) a velkého počtu záměn směrů\n(--permutations) myslete na svůj výpočetní výkon!\n");
    printf("Nelze používat sdružené přepínače, jako -ds, na pořadí přepínačů nezáleží,\npři opakovaném uvedení platí vždy později uvedený.\n\n");

    printf("Licence: GNU/GPL, Open Source.\nAutor: made by m@tlin\nČervenec - Září 2012\n");
    printf("Chyby hlaste do /dev/null, nebo na martlin@seznam.cz\n");
}

void mapSettings(void) {
    #define READ_PRINT_BOOL(number, label, var) \
        PRINTF(label);\
        if (select==number) {\
            var=!var;\
            select='\0';\
        }\
        PRINTF("%s\n", printBool(var));\

     #define READ_PRINT_ALG(number, label, var) \
        PRINTF(label);\
        if (select==number) {\
            if (var==fullRand) var=beginRand; \
                          else var=fullRand; \
            select='\0';\
        } \
        if (var==fullRand) PRINTF("Slozity, klikate cesty\n"); \
                      else PRINTF("Jednoduchy, rovne cesty\n");\


    #define READ_PRINT_INT(number, label, var)\
        PRINTF(label);\
        if (select==number) {\
            PRINTF("      \b\b\b\b\b\b");\
            SCANF("%d", &var);\
            select='\0';\
            continue;\
        } else PRINTF("%d\n", var);\

    #define READ_PRINT_CHAR(number, label, var)\
        PRINTF(label);\
        if (select==number) {\
            PRINTF(" \b");\
            SCANF("%c", &var);\
            select='\0';\
            continue;\
        } else PRINTF("%c\n", var);

    #ifdef USE_CURSES
        curs_set(2);
    #endif

    char select='\0';
    CLEAR;

    do {
        myFflush(stdin);
        GOTO00;

        PRINTF("Stiskem cisla vyberte parametr k prenastaveni, nebo Q/X pro konec:\n\n");
        PRINTF(" 0. Obnovit vse vychozi\n");
        if (select=='0') {
            select='\0';    //musíme anulovat volbu
            restoreDefaultMapS();
            continue;
        }

        if (IS_MAP_SMALL) {
            bool isHoriz=(gameParams::width>gameParams::height); //je to obdélník orientovaný horizontálně (úzký, vysoký)?

            PRINTF("Mapa je prilis mala, zvetsete ji na alespon 7x5 nebo 5x7.\n");
            if ((isHoriz && gameParams::width<5 )|| (!isHoriz && gameParams::width<7))
                select='1';
            else if ((isHoriz && gameParams::height<7) || !(isHoriz && gameParams::height<5))
                select='2';
            else
                PRINTF("ERR\n");

        } else
            PRINTF("\n");

        READ_PRINT_INT('1',     " 1. Sirka labyrintu                         ", gameParams::width);

        if (IS_MAP_SMALL)
            select='2';

        READ_PRINT_INT('2',     " 2. Vyska labyrintu                         ", gameParams::height);

        PRINTF("\n");
        READ_PRINT_ALG('3',     " 3. Labyrint ...                            ", gameParams::algorithm);
        READ_PRINT_BOOL('4',    " 4. Start vlevo (nebo kdekoliv)?            ", gameParams::startOnLeft);
        READ_PRINT_BOOL('5',    " 5. Cil vpravo (nebo kdekoliv)?             ", gameParams::finishOnRight);
        READ_PRINT_INT('6',     " 6. Maximalni pocet reseni labyrintu        ", gameParams::shortcuts);
        PRINTF("\n");
        READ_PRINT_BOOL('7',    " 7. Zobrazovat labyrint (jinak hra naslepo) ", gameParams::visible);
        READ_PRINT_BOOL('8',    " 8. Odhazovat cestou seminka?               ", gameParams::dropSeeds);

        #ifdef USE_CURSES
            refresh();
        #endif

        select=toUpperCase(READKEY);

    } while (select!='Q' && select!='X');

    #ifdef USE_CURSES
        curs_set(0);
    #endif

}

void gameSettings(void) {
    #ifdef USE_CURSES
        curs_set(2);
    #endif
    char select='\0';
    CLEAR;
    do {
        myFflush(stdin);
        GOTO00;
        PRINTF("Stiskem cisla vyberte parametr k prenastaveni, nebo Q/X pro konec:\n\n");
        PRINTF(" 0. Obnovit vse vychozi\n");
        if (select=='0') {
            select='\0';    //musíme anulovat volbu
            restoreDefaultGameS();
            continue;
        }

        #ifndef USE_CURSES
            PRINTF("Velikost terminalu, do ktereho se vykresluje labyrint.\nStandartne je 80x25. Pokud si nejste jisti, zadejte radeji mene nez vice.\n");
            READ_PRINT_INT('1', " 1. Sirka terminalu                ", gameParams::termWidth);
            READ_PRINT_INT('2', " 2. Vyska terminalu                ", gameParams::termHeight);
        #endif
        PRINTF("\n");
        PRINTF("Pri generovani se prehazuji smery, kterymi se vydava token.\nDostacujici je hodnota 1, nad 3 je zbytecne (navic dele trva).\n");
        READ_PRINT_INT('3',     " 3. Pocet prohozeni smeru          ", gameParams::permutations);
        PRINTF("\n");
        PRINTF("Nastaveni znaku, ktere se budou vykreslovat v labyrintu:\n");
        READ_PRINT_CHAR('4',    " 4. Prazdne pole                   ", gameParams::empty);
        READ_PRINT_CHAR('5',    " 5. Zed                            ", gameParams::wall);
        READ_PRINT_CHAR('6',    " 6. Navstivene pole (\"Seminko\")    ", gameParams::visited);
        READ_PRINT_CHAR('7',    " 7. Start                          ", gameParams::start);
        READ_PRINT_CHAR('8',    " 8. Cil                            ", gameParams::finish);
        READ_PRINT_CHAR('9',    " 9. Hrac                           ", gameParams::player);



        #ifdef USE_CURSES
            refresh();
        #endif

        select=toUpperCase(READKEY);

    } while (select!='Q' && select!='X');

    #ifdef USE_CURSES
        curs_set(0);
    #endif

}

void campaigne(void) {
    char select='\0';
    int lvl=0, levels=91;   //91 je můj rok narození :-D

    myFflush(stdin);
    CLEAR;
    PRINTF("Pribeh\n\n");
    PRINTF("Anny si poklidne pracuje ve sve laboratori, kdyz se ji podari nakrizit\na geneticky zmutovat jistý druh travy (nemyslim konopi), \
ktery se ji vymkne\nz rukou a zacne se velmi rychle rozrustat po celem vyzkumnem ustavu.\nAno, tak trochu Sipkova Ruzenka.\n\n");
    PRINTF("Anny tak nezbyva nic jineho nez se dat na utek, nez ji tyto zakerne rostliny\nuvezni.\n\n");

    PRINTF("Nejdrive utecete z vasi skromne laboratore, kde si soucastne odzkousite\novladani hry. Pote vas bude cekat dalsich %d laboratori, \
skladu, chodeb, saten,\ndezinfekcnich mistnosti, nadvori, vratnic a dalsich mistnosti, nez se dostanete\nz vyzkumneho ustavu ven, do bezpeci.\n\n", levels);

    PRINTF("Stiskem Q/X se muzete kdykoliv vratit do hlavniho menu.\n");

    #ifdef USE_CURSES
        refresh();
    #endif
    select=toUpperCase(READKEY);

    if (select=='Q' || select=='X') //navrat do menu
            return;

    for (lvl=0; lvl<=levels; lvl++) {
        CLEAR;
        PRINTF("Mistnost %d., priprav se!\n", lvl);
        PRINTF("(Klavesy Q nebo X - konec)\n");

        select=toUpperCase(READKEY);

        if (select=='Q' || select=='X') //navrat do menu
            return;

        if (select=='L') {
            CLEAR;
            PRINTF("Zadej cislo mistnosti, kterou chces hrat: ");
            SCANF("%d",&lvl);
            lvl--;  //na začátku každého cyklu se provede inkrementace
            continue;
        }
        using namespace gameParams;
        seed=lvl;

        if (lvl==0) {
            width=40;
            height=13;
            startOnLeft=false;
            finishOnRight=true;
            shortcuts=40;
        } else {
            startOnLeft=true;
            shortcuts=rand()%(levels-lvl);   //počet cest bude klesat
            if (lvl==rand()%9) {    //chodba vodorovná
                width=30+rand()%120;
                height=8+rand()%10;
            } else if (lvl==rand()%13) {    //chodba svislá
                width=10+rand()%12;
                height=12+rand()%40;
            } else {
                width=40+rand()%(lvl);
                height=15+rand()%(lvl/2+1);
            }
        }
        CLEAR;

        Map map;
        if (!map.play())
            return;  //ukončení hry
    }
}

void gameHelp(void) {
    CLEAR;
    myFflush(stdin);

    PRINTF("Anny's Lab napoveda ke hre:\n\n");
    PRINTF("Anny's Lab je bludistovka. Zacinate na policku oznacenem ");
    #ifdef USE_CURSES
        addch(gameParams::start | COLOR_PAIR(startColor));
    #else
        PRINTF("%c", gameParams::start);
    #endif
    PRINTF(" a postavickou Anny,\n");
    #ifdef USE_CURSES
        addch(gameParams::player | COLOR_PAIR(playerColor));
    #else
        PRINTF("%c", gameParams::player);
    #endif
    if (gameParams::player=='@')
        PRINTF(" (odtud jeji jmeno)");
    PRINTF(", se musite dostat do cile - ");
    #ifdef USE_CURSES
        addch(gameParams::finish | COLOR_PAIR(finishColor));
    #else
        PRINTF("%c", gameParams::finish);
    #endif
    PRINTF(".\n\n");

    PRINTF("K pohybu po labyrintu slouzi klavesy A, W, S a D nebo pripadne 4, 8, 2 a 6.\n");

    PRINTF("Mate-li mapu skrytu (\"hra na slepo\"), ovladate ji stejne, akorat misto mapy\n\
vidite jen hlasku, kdyz narazite do zdi. Mapu si vsak můzete jednorazove\n\
zobrazit stiskem klavesy N.\n\n");

    PRINTF("Pokud vas prestane bavit prochazet labyrint ze startu do cile, muzete si do\n\
labyrintu vlozit nekolik velikonocnich vajicek stiskem E nebo nuly a ty cestou  sbirat.\n");

    PRINTF("Ve hre je definovan cheat, ktery se vas pokusi presunout na nahodnou pozici.\n\
Jakou klavesou se aktivuje si musite zjistit sami.\n\n");

    PRINTF("Strucne informace o rozmisteni v labyrintu ziskate stiskem I, rozehrany\n\
labyrint ukoncite sitskem Q nebo X, stiskem H pak zobrazite velmi strucny\n\
prehled o pouzitelnych klavesach pri hre.\n\n");

    PRINTF("Hru je mozne spoustet s rozlicnymy parametry na prikazove radce.\n\
Odkazi vas na napovedu (prepinac -h nebo --help).\n\n");

    PRINTF("Preji hodne zabavy s Anny's Lab! Autor m@rtlin  ");

    READKEY;
}

#endif
