/*****************************************************************************/
/*
    Anny's Lab 1.0
    made by m@rtlin, VII-IX 2012
    martlin@seznam.cz, http://www.martlins-web.tode.cz/
    Licence: GNU/GPL, Open Source

    Multiplatformní (primárně určena pro GNU/Linux) textová bludišťovka volitelně využívající knihovnu ncurses
    Přeji Hodně zábavy!
*/
/*
    Použití knihovny ncurses:
    LINUX:
        Knihovnu ncurses nainstalujete například (záleží na distribuci):
				# apt-get install ncurses-dev

        Pokud kompilujete napřímo (použitím g++) budete muset zadat přepínač -lncurses,
        nebo zakomentovat řádek "#define USE_CURSES" v souboru declarations.cpp a knihovnu ncurses nepoužívat

        Pokud kompilujete použtím make, je ve výchozím nastavení zapnuté její použití.
        Pokud ji nechcete používat, mustíte volat make s parametrem: "make no-use-curses=1"
    WINDOWS:
        Na windows se mi ji bohužel nepodařilo sehnat a je proto nutné rovnou zakomentovat řádek #define USE_CURSES" v souboru declarations.cpp a knihovnu ncurses nepoužívat
*/
/*
    Soubor main.cpp:

    Jen funkce int main.
*/
/*****************************************************************************/
#ifndef _al_main
#define _al_main

#include <cstdlib>
#include <cstdio>
#include <ctime>
#include <string>
#include <queue>

#include "declarations.cpp"
#include "fundec.cpp"
#include "others.cpp"
#include "core.cpp"
#include "points.cpp"
#include "twodimarr.cpp"
#include "map.cpp"

/* --- Hlavní funkce int main ---------------------------------------------- */
int main(int argc, char *argv[]) {

    restoreDefaults();

    if (argc>1) {   //není-li zadán žádný argument, je toto celé zbytečné
        int i;
        std::queue<std::string> argsq;

        for (i=1; i<argc; i++)  //arguementy nacpem do fronty stringů
            argsq.push(std::string(argv[i]));

        parseArgs(argc, argsq);
    }


    #ifdef USE_CURSES
        initscr();
        curs_set(0);
        scrollok(stdscr, true);

        start_color();  //initicalizace barev
        init_pair(startColor, COLOR_BLUE, COLOR_BLACK);
        init_pair(playerColor, COLOR_GREEN, COLOR_BLACK);
        init_pair(finishColor, COLOR_RED, COLOR_BLACK);
        init_pair(wallColor, COLOR_WHITE, COLOR_BLACK);
        init_pair(emptyColor, COLOR_WHITE, COLOR_BLACK);
        init_pair(visitedColor, COLOR_YELLOW, COLOR_BLACK);
    #endif

    if (gameParams::onlyOneGame) {
        Map map;
        map.play();
    } else
        mainMenu(); //celé jádro aplikace, UI hra

    #ifdef USE_CURSES
        endwin();
    #endif
    return 0;

}

#endif
