/*****************************************************************************/
/*
    Anny's Lab 1.0
    made by m@rtlin, VII-IX 2012
    martlin@seznam.cz, http://www.martlins-web.tode.cz/
    Licence: GNU/GPL, Open Source

    Multiplatformní (primárně určena pro GNU/Linux) textová bludišťovka volitelně využívající knihovnu ncurses
    Přeji Hodně zábavy!
*/
/*
    Soubor points.cpp:

    Implementace tříd Point a z ní odvozené třídy DrawablePoint.
*/
/*****************************************************************************/
#ifndef _al_points
#define _al_points

#include <cstdlib>
#include <cstdio>

#include "declarations.cpp"
#include "fundec.cpp"
#include "others.cpp"

/*****************************************************************************/
/** Trida point, bod o odvou soradnicich *************************************/
class Point {
private:
    int x;
    int y;
public:
    Point(void);    //konstrutkory
    Point(int initX, int initY);

    int getX(void);    //zapouzdreni
    int getY(void);

    Point move(int offX, int offY);    //presun o
    Point move(Point offPoint);
    Point operator +=(Point offset);

    Point moveTo(int x, int y);  //presun na
    Point moveTo(Point newPoint);
    Point operator =(Point newPoint);

    bool operator ==(Point point2); //porovnavani
    bool operator <(Point point2);
    bool operator >(Point point2);

    bool isPositive(void);    //pomocne metody

    ~Point(void);
};

/* --- Konstruktory ---------------------------------------------------------*/
Point::Point(void){
    x=0;
    y=0;
}

Point::Point(int initX, int initY){
    x=initX;
    y=initY;
}

/* --- Zapouzdreni ----------------------------------------------------------*/
int Point::getX(void) {
    return x;
}

int Point::getY(void) {
    return y;
}

/* --- Presun o -------------------------------------------------------------*/
Point Point::move(int offX, int offY){
    Point oldPoint=*this;
    x+=offX;
    y+=offY;
    return oldPoint;
}

Point Point::move(Point offPoint){
    return move(offPoint.getX(), offPoint.getY());
}

Point Point::operator +=(Point offPoint) {
    return move(offPoint);
}

/* --- Presun na ------------------------------------------------------------*/
Point Point::moveTo(int newX, int newY){
    Point oldPoint=*this;
    x=newX;
    y=newY;
    return oldPoint;
}

Point Point::moveTo(Point newPoint){
    return moveTo(newPoint.getX(), newPoint.getY());
}

Point Point::operator =(Point newPoint) {
    return moveTo(newPoint);
}

/* --- Proovanvani ----------------------------------------------------------*/
bool Point::operator ==(Point point2) {
    return x==point2.getX() && y==point2.getY();
}

bool Point::operator <(Point point2) {
    return x<point2.getX() && y<point2.getY();
}

bool Point::operator >(Point point2) {
    return x>point2.getX() && y>point2.getY();
}

/* --- Pomocne metody --------------------------------------------------------*/
bool Point::isPositive(void) {
    return x>=0 && y>=0;
}
/* --- Destruktor -----------------------------------------------------------*/
Point::~Point(void){
    x=0;
    y=0;
}

/*****************************************************************************/
/** Trida Drawable Point, obsahujici souradnice kam vykreslit a jaky znak ****/
class DrawablePoint : public Point {
    private:
        char charToDraw;
    public:
        DrawablePoint(char newChar);    //konstrutkory
        DrawablePoint(Point coords, char newChar);
        DrawablePoint(int newX, int newY, char newChar);
        char getCharToDraw(void);   //zapouzdreni
};

/* --- Konstrutkory ---------------------------------------------------------*/
DrawablePoint::DrawablePoint(char newChar) {
    charToDraw=newChar;
}

DrawablePoint::DrawablePoint(Point coords, char newChar) : Point(coords) {
    charToDraw=newChar;
}

DrawablePoint::DrawablePoint(int newX, int newY, char newChar)  : Point(newX, newY){
    charToDraw=newChar;
}

/* --- Zapouzdreni -----------------------------------------------------------*/
char DrawablePoint::getCharToDraw(void){
    return charToDraw;
}

#endif
