/*****************************************************************************/
/*
    Anny's Lab 1.0
    made by m@rtlin, VII-IX 2012
    martlin@seznam.cz, http://www.martlins-web.tode.cz/
    Licence: GNU/GPL, Open Source

    Multiplatformní (primárně určena pro GNU/Linux) textová bludišťovka volitelně využívající knihovnu ncurses
    Přeji Hodně zábavy!
*/
/*
    Soubor twodimarr.cpp:

    Implementace třídy TwoDimArr.
*/
/*****************************************************************************/
#ifndef _al_twodimarr
#define _al_twodimarr

#include <cstdlib>
#include <cstdio>
#include <ctime>

#include "declarations.cpp"
#include "fundec.cpp"
#include "others.cpp"
#include "core.cpp"
#include "points.cpp"

/*****************************************************************************/
/** Trida TwoDimArray, dvourozmerene pole uchovavajici svou  velikost ********/
class TwoDimArr {
private:
    Point* size;
    char** items;

public:
    TwoDimArr(int newW, int newH);  //konstruktory
    TwoDimArr(int newW, int newH, char newItem);

    char** getItems(void);     //zapouzdreni
    char getItem(Point onPoint);
    void setItem(Point onPoint, char newItem);
    void setItem(DrawablePoint pointToSet);

    Point getSize(void);

    void setTo(char newItem);   //vyplneni

    //metody na vypis

    bool inBounds(Point p);  //pomocne metody

    ~TwoDimArr(void);   //destrutkor
};

/* --- Konstruktory ----------------------------------------------------------*/
TwoDimArr::TwoDimArr(int newW, int newH) {
    int i;
    size=new Point(newW, newH);
    items=new char*[size->getX()];
    for (i=0; i<size->getX(); i++)
        items[i]=new char[size->getY()];
}

TwoDimArr::TwoDimArr(int newW, int newH, char newItem) {
    int i,j;
    size=new Point(newW, newH);
    items=new char*[size->getX()];
    for (i=0; i<size->getX(); i++) {
        items[i]=new char[size->getY()];
        for (j=0; j<size->getY(); j++)
            items[i][j]=newItem;
    }
}

/* --- Zapouzdreni ----------------------------------------------------------*/
Point TwoDimArr::getSize(void) {
    return *size;
}

char** TwoDimArr::getItems(void){
    return items;
}

char TwoDimArr::getItem(Point onPoint){
    if (inBounds(onPoint))
        return items[onPoint.getX()][onPoint.getY()];
    else
        return EOF;
}

void TwoDimArr::setItem(Point onPoint, char newItem){
    if (inBounds(onPoint))
        items[onPoint.getX()][onPoint.getY()]=newItem;
}

void TwoDimArr::setItem(DrawablePoint pointToSet){
    setItem(pointToSet, pointToSet.getCharToDraw());
}

/* --- Pomocne metody -----------------------------------------------------*/
bool TwoDimArr::inBounds(Point p) {
    return p.isPositive() && p<getSize();
}

/* --- Destruktor ----------------------------------------------------------*/
TwoDimArr::~TwoDimArr(void) {
    int i;
    if (!items) return;
    for (i=0; i<size->getX(); i++)
        if (items[i])
            delete items[i];
    delete items;
    delete size;
}

#endif
